;nyquist plug-in
;version 4
;type analyze
;name "Import Labels"
;author "Steve Daulton"
;copyright "GNU General Public License v2.0 or later"


;; Limitations:
;; 1. Frequency ranges (if present in labels) are ignored.
;; 2. Supports plain ASCII text only (no multi-byte characters)


;control fname "Select file" file "" "*default*/Label Track.txt" "Text file|*.txt;*.TXT|All files|*.*;*" "open,exists"

(defun label-from-txt(txt)
  (do ((out "(list ")
       (tabcount 0)
       (i 0 (1+ i)))
      ((= i (length txt)) (eval-string (string-append out "\")")))
    (cond ((char= (char txt i) #\tab)
              (incf tabcount)
              (string-append out " ")
              (when (= tabcount 2)
                (string-append out "\"")))
          (t (string-append out (string (char txt i)))))))


(let ((fp (open fname))
      (labels ()))
  (do ((line (read-line fp) (read-line fp)))
      ((not line) labels)
    (unless (char= (char line 0) #\\)
      (push (label-from-txt line) labels))))
